class Hanoi {
	Stack [] Tours;
	int maxSize;
	public Hanoi(int n){
		Tours = new Stack [3];
		for(int i=0;i<3;i++) Tours[i] = new ArrayStack();
		maxSize = n;
		for(int i=n; i>=1; i--)
			Tours[0].push(i);
	}
	public String toString(){
		String s = "Current state:\n";
		s+= "Tour 0:" + Tours[0] + "\n";
		s+= "Tour 1:" + Tours[1] + "\n";
		s+= "Tour 2:" + Tours[2] + "\n";
		return s;
	}
	
	public void doSimpleMove(int from, int to){
		if(Tours[from].isEmpty()){
			System.out.println("Error: empty source: moving from "+from+" to "+to);
			System.out.println(this);
			return;
		}
		int f = (Integer)Tours[from].top();
		int t = Tours[to].isEmpty() ? maxSize+1 : (Integer)Tours[to].top();
		if(f>t){
			System.out.println("Error: wrong size: moving from "+from+" to "+to);
			System.out.println(this);
			return;
		}
		Tours[to].push(Tours[from].pop());
		System.out.println(this);
	}

	public void doComplexMove(int from, int to, int num){
		if(num==0) return;
		if(num==1) {doSimpleMove(from,to); return;}
		int other = 3-from-to;
		doComplexMove(from,other,num-1);
		doSimpleMove(from,to);
		doComplexMove(other,to,num-1);
	}

	public static void main(String [] args){
		Hanoi H = new Hanoi(5);
		System.out.println(H);
		H.doComplexMove(0,1,5);
		System.out.println(H);
		//Non-recursive solution below
		System.out.println("Non-Recursive Solution below!!");
		H = new Hanoi(5);
		Stack Moves = new ArrayStack();
		int [] move1 = {0,1,5};
		Moves.push(move1);
		while(!Moves.isEmpty()){
			int [] thisMove = (int [])Moves.pop();
			if(thisMove[2]==1) H.doSimpleMove(thisMove[0],thisMove[1]);
			else{
				int other = 3 - thisMove[0] - thisMove[1];
				int [] newMove1 = {thisMove[0], other, thisMove[2]-1};
				int [] newMove2 = {thisMove[0], thisMove[1], 1};
				int [] newMove3 = {other, thisMove[1], thisMove[2]-1};
				Moves.push(newMove3);
				Moves.push(newMove2);
				Moves.push(newMove1);
			}
		}
	}
}

