abstract class Stack {
	abstract public void push(Object o);
	abstract public Object pop();
	abstract public String toString();
	public Object top(){
		Object o = pop();
		push(o);
		return o;
	}
	abstract public boolean isEmpty();
}

class ArrayStack extends Stack{
	private Object [] data;
	int size=0;
	public boolean isEmpty() { return size==0; }
	private void doubleSize(){
		Object [] data2 = new Object[data.length*2];
		for(int i=0;i<data.length;i++)
			data2[i]=data[i];
		data = data2;
	}
	public void push(Object o){
		if(data==null){ data = new Object[1];
			size = 1; data[0] = o; return; }
		if(size == data.length) doubleSize();
		data[size++]=o;
	}
	public Object pop(){
		if(isEmpty()) return null;
		return data[--size];
	}
	public String toString(){
		String s="";
		for(int i=0; i<size; i++)
			s += data[i].toString();
		return s;
	}
}
